## xdaliclock 2.35+debian

=== Makefile ===
# xdaliclock, Copyright (c) 1991-2006 by Jamie Zawinski.

SHELL		= /bin/sh
TARFILES	= README Makefile version.h \
		  config.guess config.sub install-sh \
		  mac128/README mac128/*.*
NUMBERS		= font/*.pl font/dalifont*.{gif,gz} font/*.xbm
TAR		= tar


default:
	@echo ''; \
	 echo '        please make one of: "x", "palm", "webos", "all", or "clean"'; \
	 echo ''; \
	 exit 5

all:: OSX webos palm X11

X11::   x11
X::     X11
x::     X11
gtk::   GTK
OSX::   osx
palm::  Palm
webos:: WebOS

x11:: X11/Makefile
	@echo '==============================================================='
	@echo ''
	cd X11 ; make

GTK:: gtk/Makefile
	@echo '==============================================================='
	@echo ''
	cd gtk ; make

osx::
	@echo '==============================================================='
	@echo ''
	cd OSX ; make

Palm:: palm/Makefile
	@echo '==============================================================='
	@echo ''
	cd palm ; make

WebOS:: webos/Makefile
	@echo '==============================================================='
	@echo ''
	cd webos ; make

X11/Makefile:
	@echo '==============================================================='
	@echo ''
	cd X11 ; ./configure

gtk/Makefile:
	@echo '==============================================================='
	@echo ''
	cd gtk ; ./configure

palm/Makefile:
	@echo '==============================================================='
	@echo ''
	cd palm ; ./configure --host=m68k-palmos --build=`../config.guess`

clean: X11/Makefile palm/Makefile
	cd X11 ; make $@
	cd gtk ; make $@
	cd OSX ; make $@
	cd palm ; make $@
	cd webos ; make $@

distclean: X11/Makefile gtk/Makefile palm/Makefile
	cd X11 ; make $@
	cd gtk ; make $@
	cd OSX ; make $@
	cd palm ; make $@
	cd webos ; make $@

install:
	@echo ''; \
	 echo '      - to install the X11 version: "cd X11; make install".';   \
	 echo ''; \
	 echo '      - to install the MacOS version: "cd OSX; make"';	     \
	 echo '        then copy "build/Development/DaliClock.app"';	     \
	 echo '        to your Applications folder."';			     \
	 echo ''; \
	 echo '      - to install the PalmOS version: "cd palm; make", and'; \
	 echo '        then download "daliclock.prc" to your PalmOS device.';\
	 echo ''; \
	 echo '      - to install the WebOS version: "cd webos; make", and'; \
	 echo '        then send the .ipk to your Palm WebOS device.';\
	 echo ''; \
	 exit 5

dmg::
	cd OSX ; $(MAKE) dmg

tar: X11/Makefile gtk/Makefile palm/Makefile dmg
	@								    \
  for dir in X11 gtk palm ; do						    \
   ( cd $$dir ;								    \
     rm -f configure ;							    \
     autoconf263 ;							    \
     ./config.status ;							    \
     $(MAKE) distdepend );						    \
  done ;								    \
  (cd X11; make update_spec_version) ;					    \
  (cd gtk; make update_spec_version) ;					    \
  (cd palm; make update_rsc_version) ;					    \
  (cd webos; make update_release_date) ;				    \
  (cd OSX; make update_plist_version) ;					    \
  NAME=`sed -n								    \
  's/[^0-9]*\([0-9]\.[0-9][0-9]*\).*/xdaliclock-\1/p' version.h` ;	    \
  rm -rf $$NAME ; ln -s . $$NAME ;					    \
  FILES= ;								    \
  for subdir in X11 gtk palm OSX webos ; do				    \
    d=`pwd` ;								    \
    cd $$subdir ;							    \
    FILES="$$FILES `$(MAKE) echo_tarfiles				    \
      | grep -v '^.*make\['						    \
      | sed \"s|^|$$subdir/|g;s| | $$subdir/|g\"			    \
      ` ";								    \
    cd $$d ; done ;							    \
  echo creating tar file archive/$${NAME}.tar.gz... ;			    \
  GZIP="-9v" $(TAR) -vchzf archive/$${NAME}.tar.gz			    \
    `echo $(TARFILES) $$FILES $(NUMBERS)				    \
   | sed "s|^|$$NAME/|g; s| | $$NAME/|g" ` ;				    \
  rm $$NAME ;								    \
  ls -ldF archive/$${NAME}.tar.gz

www::
	@								    \
  DEST=$$HOME/www/xdaliclock ;						    \
  VERS=`sed -n 's/[^0-9]*\([0-9]\.[0-9][0-9]*\).*/\1/p' version.h`	 ;  \
  VERS2=`echo $$VERS | sed 's/[.]//g'`					 ;  \
  HEAD="daliclock-$$VERS"						 ;  \
  HEAD2="daliclock-$$VERS2"						 ;  \
  HEAD3="DaliClock-$$VERS2"						 ;  \
  TAR="x$$HEAD.tar.gz"							 ;  \
  DMG="$$HEAD3.dmg"							 ;  \
									    \
  if [ ! -f archive/$$TAR ]; then					    \
    echo "archive/$$TAR does not exist!  Did you forget to \`make tar'?" ;  \
    exit 1 ; 								    \
  fi ;									    \
									    \
  if [ ! -f archive/$$DMG ]; then					    \
    echo "archive/$$DMG does not exist!  Did you forget to \`make dmg'?" ;  \
    exit 1 ; 								    \
  fi ;									    \
  chmod a-w archive/$$TAR ;						    \
  chmod a-w archive/$$DMG ;						    \
									    \
  if [ -f $$DEST/$$TAR ]; then						    \
    /bin/echo -n "WARNING: $$DEST/$$TAR already exists!  Overwrite? ";	    \
    read line;								    \
    if [ "x$$line" != "xyes" -a "x$$line" != "xy" ]; then		    \
      exit 1 ; 								    \
    fi ;								    \
  fi ;									    \
									    \
  if [ -f $$DEST/$$DMG ]; then						    \
    /bin/echo -n "WARNING: $$DEST/$$DMG already exists!  Overwrite? ";	    \
    read line;								    \
    if [ "x$$line" != "xyes" -a "x$$line" != "xy" ]; then		    \
      exit 1 ; 								    \
    fi ;								    \
  fi ;									    \
									    \
  cp -p archive/$$TAR $$DEST/$$TAR ;					    \
  chmod u+w $$DEST/$$TAR ;						    \
									    \
  cp -p archive/$$DMG $$DEST/$$DMG ;					    \
  chmod u+w $$DEST/$$DMG ;						    \
									    \
  cd $$DEST ;								    \
									    \
  TMP=/tmp/xd.$$$$ ;							    \
  sed -e "s/daliclock-[0-9]\.[0-9][0-9]*/$$HEAD/g"			    \
      -e "s/daliclock-[0-9][0-9][0-9]*/$$HEAD2/g"			    \
      -e "s/DaliClock-[0-9][0-9][0-9]*/$$HEAD3/g"			    \
      index.html > $$TMP ;						    \
  echo '' ;								    \
  diff -U0 index.html $$TMP ;						    \
  echo '' ;								    \
									    \
  OLDEST=`ls xdaliclock*.tar.gz | head -1` ;				    \
  /bin/echo -n "Delete $$DEST/$$OLDEST? ";				    \
  read line;								    \
  if [ "x$$line" = "xyes" -o "x$$line" = "xy" ]; then			    \
    set -x ;								    \
    rm $$OLDEST ;							    \
    cvs remove $$OLDEST ;						    \
    set +x ;								    \
  fi ;									    \
									    \
  OLDEST=`ls DaliClock*.dmg | head -1` ;				    \
  /bin/echo -n "Delete $$DEST/$$OLDEST? ";				    \
  read line;								    \
  if [ "x$$line" = "xyes" -o "x$$line" = "xy" ]; then			    \
    set -x ;								    \
    rm $$OLDEST $$OLDEST2 ;						    \
    cvs remove $$OLDEST $$OLDEST2 ;					    \
    set +x ;								    \
  fi ;									    \
									    \
  cat $$TMP > index.html ;						    \
  rm -f $$TMP ;								    \
									    \
  set -x ;								    \
  cvs add -kb $$TAR $$DMG ;						    \
  cvs commit -m "$$VERS"

=== debian/changelog ===
xdaliclock (2.35+debian-1) unstable; urgency=low

  * New upstream release
  * debian/control:
    + Updated to Standards-Version 3.9.2
  * debian/copyright:
    + Updated for latest DEP-5 format

 -- Kartik Mistry <kartik@debian.org>  Wed, 11 May 2011 21:49:03 +0530

=== debian/control ===
Source: xdaliclock
Section: x11
Priority: optional
Build-Depends: debhelper (>= 7),
               autotools-dev,
               libx11-dev,
               libxext-dev,
               libxt-dev,
               x11proto-core-dev
Maintainer: Kartik Mistry <kartik@debian.org>
Standards-Version: 3.9.2
Homepage: http://www.jwz.org/xdaliclock/

Package: xdaliclock
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Melting digital clock
 The xdaliclock program displays a digital clock; when a digit changes, it
 "melts" into its new shape.
 .
 It can display in 12 or 24 hour modes, and displays the date when a mouse
 button is held down. It has two large fonts built into it, but it can animate
 most other fonts that contain all of the digits. It can also do some funky
 psychedelic colormap cycling, and can use the "shape" extension so that the
 window is shaped like the digits.

## xdaliclock 2.36%2Bdebian

=== debian/changelog ===
xdaliclock (2.36+debian-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright:
    + Typo fix. Applied wrap-and-sort.

 -- Kartik Mistry <kartik@debian.org>  Sun, 06 May 2012 14:11:22 +0530

xdaliclock (2.35+debian-2) unstable; urgency=low

  * debian/rules:
    + Added missing recommended targets.
  * debian/control:
    + Updated to Standards-Version 3.9.3
  * debian/copyright:
    + Updated to copyright-format 1.0
    + Fixed License section for some paragraphs.

 -- Kartik Mistry <kartik@debian.org>  Thu, 15 Mar 2012 09:30:37 +0530

## xdaliclock 2.36+debian

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 TARFILES	= README Makefile version.h \
 		  config.guess config.sub install-sh \
 		  mac128/README mac128/*.*
-NUMBERS		= font/*.pl font/dalifont*.{gif,gz} font/*.xbm
+NUMBERS		= font/dalifont*.{gif,gz} font/*.xbm
 TAR		= tar
 
 
@@ -186,25 +186,17 @@
   diff -U0 index.html $$TMP ;						    \
   echo '' ;								    \
 									    \
-  OLDEST=`ls xdaliclock*.tar.gz | head -1` ;				    \
-  /bin/echo -n "Delete $$DEST/$$OLDEST? ";				    \
-  read line;								    \
-  if [ "x$$line" = "xyes" -o "x$$line" = "xy" ]; then			    \
-    set -x ;								    \
-    rm $$OLDEST ;							    \
-    cvs remove $$OLDEST ;						    \
-    set +x ;								    \
-  fi ;									    \
-									    \
-  OLDEST=`ls DaliClock*.dmg | head -1` ;				    \
-  /bin/echo -n "Delete $$DEST/$$OLDEST? ";				    \
-  read line;								    \
-  if [ "x$$line" = "xyes" -o "x$$line" = "xy" ]; then			    \
-    set -x ;								    \
-    rm $$OLDEST $$OLDEST2 ;						    \
-    cvs remove $$OLDEST $$OLDEST2 ;					    \
-    set +x ;								    \
-  fi ;									    \
+  for EXT in tar.gz dmg ; do						    \
+    OLDEST=`ls xdaliclock*.$$EXT | fgrep -v 235.dmg | head -n 1` ;	    \
+    /bin/echo -n "Delete $$DEST/$$OLDEST? ";				    \
+    read line;								    \
+    if [ "x$$line" = "xyes" -o "x$$line" = "xy" ]; then			    \
+      set -x ;								    \
+      rm $$OLDEST ;							    \
+      cvs remove $$OLDEST ;						    \
+      set +x ;								    \
+    fi ;								    \
+  done ;								    \
 									    \
   cat $$TMP > index.html ;						    \
   rm -f $$TMP ;								    \

=== OSX/Makefile ===
# Dali Clock for MacOS X, Copyright (c) 2005-2011 by Jamie Zawinski.

XCODEBUILD=/Developer/usr/bin/xcodebuild
#TARGETS = -target "All Targets"
TARGETS  = -target DaliClock -target DaliClockSaver -target DaliClockWidget

default: release
all: debug release

clean:
	-rm -rf build
#	cd ..; $(XCODEBUILD) $(TARGETS) clean

distclean:
	-rm -f config.status config.cache config.log \
	  *.bak *.rej TAGS *~ "#"*
	-rm -rf autom4te*.cache
	-rm -rf build

distdepend:: update_plist_version
distdepend:: update_bindist_version

debug: distdepend
	$(XCODEBUILD) $(TARGETS) -configuration Debug   build

release:: distdepend
	$(XCODEBUILD) $(TARGETS) -configuration Release build

release:: check_versions

release:: sign


distdepend:: DaliClockPhone72.png DaliClockPhone57.png
distdepend:: DaliClockPhone50.png DaliClockPhone29.png
DaliClockPhone72.png: iTunesArtwork
	convert -resize '72x72!' $< $@
DaliClockPhone57.png: iTunesArtwork
	convert -resize '57x57!' $< $@
DaliClockPhone50.png: iTunesArtwork
	convert -resize '50x50!' $< $@
DaliClockPhone29.png: iTunesArtwork
	convert -resize '29x29!' $< $@


#CERT='iPhone Developer: Jamie Zawinski (Y5M82TL69N)'  # expired...
CERT='Jamie Zawinski'
sign:
	codesign -vfs $(CERT) build/Release/*.app
	codesign -vfs $(CERT) build/Release/*.saver
	codesign -vfs $(CERT) build/Release/*.wdgt/*.widgetplugin
#	codesign -vfs $(CERT) build/Release/*.wdgt
#	codesign -vfs $(CERT) build/Release-iphoneos/*.app

check_versions:
	@\
  U=../version.h ;							\
  V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ;]*\).*/\1/p' < $$U` ;		\
  DIR=build/Release ;							\
  RESULT=0 ;								\
  for P in `find $$DIR -name Info.plist` ; do				\
     V2=`perl -0000 -n -e						\
	'm@<key>CFBundleVersion</key>\s*<string>(.*?)</string>@si 	\
	 && print $$1' < $$P` ;						\
     if [ "$$V2" != "$$V" ] ; then					\
       echo "Wrong version: $$P ($$V2)" ;				\
       RESULT=1 ;							\
     fi ;								\
  done ;								\
  if [ "$$RESULT" = 0 ]; then echo "Versions match ($$V2)" ; fi ;	\
  exit $$RESULT


echo_tarfiles:
	@echo `find . \
	  \( \( -name '.??*' -o -name build -o -name CVS -o -name '*~*' \
	     -o -name 'jwz.*' -o -name '*.widgetplugin' \
	     -o -name '*.psd' -o -name '*.ai' \) \
	     -prune \) \
	  -o -type f -print \
	| sed 's@^\./@@' \
	| sort`

update_plist_version:
	@								      \
  SS="AppInfo.plist SaverInfo.plist PluginInfo.plist iPhoneInfo.plist *.wdgt/Info.plist" ;   \
  SRC=../version.h ;							      \
  V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ]*\).*/\1/p' $$SRC` ;		      \
  Y=`date +%Y` ;							      \
  T=/tmp/xs.$$$$ ;							      \
  for S in $$SS ; do							      \
    /bin/echo -n "Updating version number in $$S to \"$$V\"... " ;	      \
    KEYS1="CFBundleVersion|CFBundleShortVersionString" ;		      \
    KEYS2="NSHumanReadableCopyright|CFBundleLongVersionString|CFBundleGetInfoString" ; \
    perl -0777 -pne							      \
      "s@(<key>($$KEYS1)</key>\s*<string>)[^<>]+(</string>)@\$${1}$$V\$${3}@g; \
       s@(<key>($$KEYS2)</key>\s*<string>[^\d]+)[\d.]+(.*?</string>)@\$${1}$$V\$${3}@gs; \
       s@(<key>($$KEYS2)</key>\s*<string>.*?1991-)\d\d\d\d(.*?</string>)@\$${1}$$Y\$${3}@gs" \
    < $$S > $$T ;							    \
   if cmp -s $$S $$T ; then						    \
     echo "unchanged." ;						    \
   else									    \
    cat $$T > $$S ;							    \
    echo "done." ;							    \
   fi ;									    \
   rm $$T ;								    \
  done


update_bindist_version:
	@								    \
  SS="bindist.rtf" ;							    \
  U=../version.h ;							    \
  V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ;]*\).*/\1/p' < $$U` ;		    \
  D=`date '+%d-%b-%Y'` ;						    \
  for S in $$SS ; do							    \
   T=/tmp/xs.$$$$ ;							    \
   sed -e "s/\(.*version \)[0-9][0-9]*\.[0-9]*[ab]*[0-9]*\(.*\)/\1$$V\2/"   \
       -e "s/\([0-9][0-9]-[A-Z][a-z][a-z]-[0-9][0-9][0-9]*\)/$$D/"	    \
      < $$S > $$T ;							    \
   if cmp -s $$S $$T ; then						    \
    true ;								    \
   else									    \
    cat $$T > $$S ;							    \
    echo "updated $$S to $$V $$D" ;					    \
   fi ;									    \
  done ;								    \
  rm $$T

# -format UDBZ saves 4% over UDZO, but that's only 8KB.
dmg:: distdepend check_versions
	@								      \
  set -e ;								      \
  SRC=../version.h ;							      \
  V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ;]*\).*/\1/p' $$SRC` ;		      \
  V2="$$V" ;								      \
  V=`echo $$V | sed 's/\.//g'` ;					      \
  TMPDIR="build" ;							      \
  SRC="build/Release" ;							      \
  BASE="DaliClock-$$V" ;						      \
  OUTDIR="../archive" ;							      \
  DMG="$$OUTDIR/$$BASE.dmg" ;						      \
  TMPDMG="$$TMPDIR/tmp.dmg" ;						      \
  VOLNAME="DaliClock $$V2" ;						      \
  STAGE="$$TMPDIR/dmg_stage" ;						      \
  rm -f "$$DMG" ;							      \
  rm -rf "$$STAGE" ;							      \
  echo + mkdir "$$STAGE" ;						      \
         mkdir "$$STAGE" ;						      \
  FILES="$$SRC/*.app $$SRC/*.saver $$SRC/*.wdgt" ;			      \
  echo + cp -pr $$FILES "$$STAGE" ;					      \
         cp -pr $$FILES "$$STAGE" ;					      \
  set -x ;								      \
  cp -p bindist.rtf "$$STAGE/ READ ME.rtf" ;				      \
  cp -p bindist-DS_Store "$$STAGE/.DS_Store" ;				      \
  cp -p bindist.webloc "$$STAGE/DaliClock for iPhone:iPad.webloc" ;	      \
  /Developer/Tools/SetFile -a E "$$STAGE/ READ ME.rtf" ;		      \
  /Developer/Tools/SetFile -a e $$STAGE/*.saver ;			      \
  /Developer/Tools/SetFile -a e $$STAGE/*.wdgt ;			      \
  /Developer/Tools/SetFile -a E $$STAGE/*.webloc ;			      \
  seticon -d daliclockSaver.icns $$STAGE/*.saver ;			      \
  seticon -d daliclockWidget.icns $$STAGE/*.wdgt ;			      \
  seticon -d daliclock.icns $$STAGE/*.webloc ;				      \
  hdiutil makehybrid -quiet -ov -hfs -hfs-volume-name "$$VOLNAME"	      \
    -hfs-openfolder "$$STAGE" "$$STAGE" -o "$$TMPDMG" ;			      \
  rm -rf "$$STAGE" ;							      \
  hdiutil convert -quiet -ov -format UDZO -imagekey zlib-level=9	      \
    "$$TMPDMG" -o "$$DMG" ;						      \
  rm -f "$$TMPDMG" ;							      \
  ls -ldhgF "$$DMG"

# Adding this is cute:
#    hdiutil internet-enable -yes -quiet "$$DMG"
# but means that nobody will ever see the display settings I used!
# When finder copies the .dmg to a folder, it doesn't preserve them.

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,19 @@
 Source: xdaliclock
 Section: x11
 Priority: optional
-Build-Depends: debhelper (>= 7),
-               autotools-dev,
+Build-Depends: autotools-dev,
+               debhelper (>= 7),
                libx11-dev,
                libxext-dev,
                libxt-dev,
                x11proto-core-dev
 Maintainer: Kartik Mistry <kartik@debian.org>
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://www.jwz.org/xdaliclock/
 
 Package: xdaliclock
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Melting digital clock
  The xdaliclock program displays a digital clock; when a digit changes, it
  "melts" into its new shape.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.

#export DH_VERBOSE=1

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp:
	dh_testdir
	ln -sf /usr/share/misc/config.sub config.sub
	ln -sf /usr/share/misc/config.guess config.guess
	cd X11 && ( CFLAGS="$(CFLAGS)" ./configure \
		--host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
		--prefix=/usr --mandir=/usr/share/man )
	cd X11 && $(MAKE) CFLAGS="$(CFLAGS)"
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	[ ! -f X11/Makefile ] || ( cd X11 && $(MAKE) distclean )
	dh_clean config.sub config.guess

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs usr/share/man/man1 usr/bin
	cd X11 && $(MAKE) install_prefix=$(CURDIR)/debian/xdaliclock install

binary-indep: build install
# We have nothing to do by default.

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs README
	dh_installmenu
	dh_installman
	dh_installchangelogs
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean build-arch build-indep binary-indep binary-arch binary install

## xdaliclock 2.37

=== OSX/Makefile ===
--- 
+++ 
@@ -1,8 +1,10 @@
 # Dali Clock for MacOS X, Copyright (c) 2005-2011 by Jamie Zawinski.
 
-XCODEBUILD=/Developer/usr/bin/xcodebuild
-#TARGETS = -target "All Targets"
-TARGETS  = -target DaliClock -target DaliClockSaver -target DaliClockWidget
+XCODEBUILD = /Developer/usr/bin/xcodebuild
+TARGETS    = -target DaliClock -target DaliClockSaver -target DaliClockWidget
+ARCH       = -arch i386 -arch x86_64
+CERT       = 'Jamie Zawinski'
+#CERT       = 'iPhone Developer: Jamie Zawinski (Y5M82TL69N)'
 
 default: release
 all: debug release
@@ -21,10 +23,10 @@
 distdepend:: update_bindist_version
 
 debug: distdepend
-	$(XCODEBUILD) $(TARGETS) -configuration Debug   build
+	$(XCODEBUILD) $(ARCH) $(TARGETS) -configuration Debug   build
 
 release:: distdepend
-	$(XCODEBUILD) $(TARGETS) -configuration Release build
+	$(XCODEBUILD) $(ARCH) $(TARGETS) -configuration Release build
 
 release:: check_versions
 
@@ -43,13 +45,11 @@
 	convert -resize '29x29!' $< $@
 
 
-#CERT='iPhone Developer: Jamie Zawinski (Y5M82TL69N)'  # expired...
-CERT='Jamie Zawinski'
 sign:
 	codesign -vfs $(CERT) build/Release/*.app
 	codesign -vfs $(CERT) build/Release/*.saver
 	codesign -vfs $(CERT) build/Release/*.wdgt/*.widgetplugin
-#	codesign -vfs $(CERT) build/Release/*.wdgt
+	codesign -vfs $(CERT) build/Release/*.wdgt
 #	codesign -vfs $(CERT) build/Release-iphoneos/*.app
 
 check_versions:

=== debian/changelog ===
xdaliclock (2.37-1) unstable; urgency=low

  * New upstream release
  * We don't repack upstream source now, hence back to normal version scheme.
  * debian/copyright:
    + Updated copyright.
    + Removed duplicate copyright field.
  * debian/control, debian/rules,
    + Added hardening support.

 -- Kartik Mistry <kartik@debian.org>  Fri, 19 Oct 2012 14:12:34 +0530

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Priority: optional
 Build-Depends: autotools-dev,
                debhelper (>= 7),
+               hardening-wrapper,
                libx11-dev,
                libxext-dev,
                libxt-dev,

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,8 @@
 # Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
 
 #export DH_VERBOSE=1
+
+export DEB_BUILD_HARDENING=1
 
 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

## xdaliclock 2.38

=== Makefile ===
--- 
+++ 
@@ -187,7 +187,7 @@
   echo '' ;								    \
 									    \
   for EXT in tar.gz dmg ; do						    \
-    OLDEST=`ls xdaliclock*.$$EXT | fgrep -v 235.dmg | head -n 1` ;	    \
+    OLDEST=`ls *.$$EXT | fgrep -v 235.dmg | head -n 1` ;		    \
     /bin/echo -n "Delete $$DEST/$$OLDEST? ";				    \
     read line;								    \
     if [ "x$$line" = "xyes" -o "x$$line" = "xy" ]; then			    \

=== debian/changelog ===
xdaliclock (2.38-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    + Added VCS-* fields.
    + Updated to Standards-Version 3.9.4
  * debian/rules:
    + Rewrote to use dh.
  * Added debian/docs file.

 -- Kartik Mistry <kartik@debian.org>  Tue, 16 Jul 2013 10:01:14 +0530

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export DEB_BUILD_HARDENING=1

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

override_dh_auto_configure:
	cd X11 && ( CFLAGS="$(CFLAGS)" ./configure \
		--host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
		--prefix=/usr --mandir=/usr/share/man )

override_dh_auto_build:
	cd X11 && $(MAKE) CFLAGS="$(CFLAGS)"

override_dh_auto_clean:
	[ ! -f X11/Makefile ] || ( cd X11 && $(MAKE) distclean )

override_dh_auto_install:
	dh_installdirs usr/share/man/man1 usr/bin
	cd X11 && $(MAKE) install_prefix=$(CURDIR)/debian/xdaliclock install

%:
	dh $@

## xdaliclock 2.39

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 TARFILES	= README Makefile version.h \
 		  config.guess config.sub install-sh \
 		  mac128/README mac128/*.*
-NUMBERS		= font/dalifont*.{gif,gz} font/*.xbm
+NUMBERS		= font/dalifont*.{gif,png,ai,psd,gz} font/*.xbm
 TAR		= tar

=== OSX/Makefile ===
--- 
+++ 
@@ -1,10 +1,10 @@
 # Dali Clock for MacOS X, Copyright (c) 2005-2011 by Jamie Zawinski.
 
-XCODEBUILD = /Developer/usr/bin/xcodebuild
+XCODEBUILD = /usr/bin/xcodebuild
 TARGETS    = -target DaliClock -target DaliClockSaver -target DaliClockWidget
 ARCH       = -arch i386 -arch x86_64
 CERT       = 'Jamie Zawinski'
-#CERT       = 'iPhone Developer: Jamie Zawinski (Y5M82TL69N)'
+CERT       = 'iPhone Developer: Jamie Zawinski (Y5M82TL69N)'
 
 default: release
 all: debug release
@@ -29,7 +29,6 @@
 	$(XCODEBUILD) $(ARCH) $(TARGETS) -configuration Release build
 
 release:: check_versions
-
 release:: sign
 
 
@@ -109,13 +108,15 @@
 
 update_bindist_version:
 	@								    \
-  SS="bindist.rtf" ;							    \
+  SS="bindist.rtf Credits.html" ;					    \
   U=../version.h ;							    \
   V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ;]*\).*/\1/p' < $$U` ;		    \
   D=`date '+%d-%b-%Y'` ;						    \
+  Y=`date '+%Y'` ;							    \
   for S in $$SS ; do							    \
    T=/tmp/xs.$$$$ ;							    \
    sed -e "s/\(.*version \)[0-9][0-9]*\.[0-9]*[ab]*[0-9]*\(.*\)/\1$$V\2/"   \
+       -e "s/\(1991-\)[0-9][0-9][0-9][0-9]/\1$$Y/"			    \
        -e "s/\([0-9][0-9]-[A-Z][a-z][a-z]-[0-9][0-9][0-9]*\)/$$D/"	    \
       < $$S > $$T ;							    \
    if cmp -s $$S $$T ; then						    \

=== webos/Makefile ===
# Dali Clock for Palm WebOS, Copyright (c) 2009 by Jamie Zawinski.

TITLE		= Dali Clock
TARGET		= DaliClock
TARGET2		= daliclock
VENDOR		= Jamie Zawinski
VERSION		= $(shell sed -n \
			's/^.*\([0-9][0-9]*\.[0-9][0-9]*\).*$$/\1.0/p' \
			< ../version.h)
ID		= org.jwz.$(TARGET2)
IPK		= $(ID)_$(VERSION)_all.ipk
DEVDIR		= /opt/PalmSDK/Current/bin
DEVICE		= tcp
CERT		= cert.pem

CC		= gcc
CFLAGS		= -g -Wall -Wstrict-prototypes -Wnested-externs
LDFLAGS		= 
DEFINES		= -DBUILTIN_FONTS
INCLUDES	= -I. -I../font -I../OSX
OBJS		= buildnumbers.o

FONTDIR		= $(TARGET)/images
NUMBERS		= $(FONTDIR)/font0.json \
		  $(FONTDIR)/font1.json \
		  $(FONTDIR)/font2.json \
		  $(FONTDIR)/font3.json \
		  $(FONTDIR)/font4.json \
		  $(FONTDIR)/font5.json

default: ipk

clean:
	rm -f *.o buildnumbers

distclean: clean
	find . \( \
	  -name '*.bak' -o -name '*.rej' -o -name '*~' -o -name '#*' \
	  \) -exec rm '{}' \;

distdepend:: update_release_date

echo_tarfiles:
	@echo `find . \
	  \( \( -name '.??*' -o -name CVS -o -name '*~*' -o -name '*.o' \
		-o -name buildnumbers -o -name '*.pem' -o -name '*.ipk' \
		-o -name '*.jpg' \
	      \) \
	     -prune \) \
	  -o -type f -print \
	| sed 's@^\./@@' \
	| sort`


.c.o:
	$(CC) -c $(INCLUDES) $(DEFINES) $(CFLAGS) $<

buildnumbers: buildnumbers.o
	$(CC) $(LDFLAGS) -o $@ $(OBJS)

$(NUMBERS): buildnumbers

$(FONTDIR)/font0.json:
	./buildnumbers 0 > $@
$(FONTDIR)/font1.json:
	./buildnumbers 1 > $@
$(FONTDIR)/font2.json:
	./buildnumbers 2 > $@
$(FONTDIR)/font3.json:
	./buildnumbers 3 > $@
$(FONTDIR)/font4.json:
	./buildnumbers 4 > $@
$(FONTDIR)/font5.json:
	./buildnumbers 5 > $@

all:: $(NUMBERS)


# Create cert.pem with:
#  openssl req -x509 -nodes -days 3650 -newkey rsa:1024 \
#   -keyout cert.pem -out cert.pem
# Keep that file secret!  It is your private key.

sign:
	@\
  if [ ! -f "$(CERT)" ]; then						      \
    echo "$(CERT) does not exist! Generate one. See Makefile." ;	      \
    exit 1 ;								      \
  fi ;									      \
  /bin/echo -n "Generating signature for \"$(IPK)\"... " ;		      \
  STAGE=sign-$$$$ ;							      \
  rm -rf $$STAGE ;							      \
  mkdir $$STAGE ;							      \
  cd $$STAGE ;								      \
  PUBKEY=pubkey.pem ;							      \
  SIG=signature.sha1 ;							      \
  openssl rsa -in ../$(CERT) -pubout -out $$PUBKEY 2>/dev/null ;	      \
  ar -x ../$(IPK) ;							      \
  FILES="control.tar.gz data.tar.gz debian-binary" ;			      \
  cat $$FILES | openssl dgst -sha1 -sign ../$(CERT) -out $$SIG ;	      \
  cat $$FILES | openssl dgst -sha1 -verify $$PUBKEY -signature $$SIG ;	      \
  FILES="$$FILES $$PUBKEY $$SIG" ;					      \
  touch -r ../$(IPK) $$FILES ;						      \
  ar -cr $(IPK) $$FILES ;						      \
  if cmp -s $(IPK) ../$(IPK) ; then					      \
    echo "Unchanged." ;							      \
  else									      \
    cat $(IPK) > ../$(IPK) ;						      \
    echo "Signature installed." ;					      \
  fi ;									      \
  cd .. ;								      \
  rm -rf $$STAGE


ipk: $(NUMBERS) ../version.h update_release_date
	$(DEVDIR)/palm-package --exclude CVS --exclude '*~' $(TARGET)
	$(MAKE) sign


update_release_date::
	@S="$(TARGET)/appinfo.json" ;					      \
  DATE=`date +%d-%h-%Y` ;						      \
  /bin/echo -n "Updating version in $$S to $(VERSION)/$$DATE... " ;	      \
  T=/tmp/xs.$$$$ ;							      \
  sed -e "s/^\(.*\"release_date\":.*\"\).*\(\".*\)$$/\1$$DATE\2/"	      \
      -e "s/^\(.*\"version\":.*\"\).*\(\".*\)$$/\1$(VERSION)\2/"	      \
     < $$S > $$T ;							      \
  if cmp -s $$S $$T ; then						      \
    echo "unchanged." ;							      \
  else									      \
    cat $$T > $$S ;							      \
    echo "done." ;							      \
  fi ;									      \
  rm $$T


palm-generate-app:
	@								      \
  if [ -d $(TARGET) ]; then						      \
    echo "$(TARGET)/ already exists" ;					      \
    exit 1 ;								      \
  fi
	$(DEVDIR)/palm-generate \
	  -p "{title:'$(TITLE)', id:$(ID), version:'$(VERSION)'}" $(TARGET)
	perl -pi -e 's/My Company/$(VENDOR)/g' $(TARGET)/appinfo.json

palm-generate-scene:
	@D=$(TARGET)/app/views/clock ;					      \
  if [ -d $$D ]; then							      \
    echo "$$D/ already exists" ;					      \
    exit 1 ;								      \
  fi
	$(DEVDIR)/palm-generate -t new_scene -p "name=Clock" $(TARGET)


palm-install:
	$(DEVDIR)/palm-install -d $(DEVICE) $(IPK)

palm-launch:
	$(DEVDIR)/palm-launch -d $(DEVICE) $(ID)

palm-kill:
	$(DEVDIR)/palm-launch -d $(DEVICE) -c $(ID) ; exit 0

reset-emulator:
	killall VirtualBoxVM
	rm $$HOME/Library/VirtualBox/Machines/Palm*/*.xml

test:: ipk palm-kill palm-install palm-launch

=== debian/changelog ===
xdaliclock (2.39-2) unstable; urgency=low

  * debian/rules:
    + Use dh --with autotools_dev so that it will update config.* files.
      (Closes: #727520)

 -- Kartik Mistry <kartik@debian.org>  Thu, 31 Oct 2013 20:09:19 +0530

xdaliclock (2.39-1) unstable; urgency=low

  * New upstream release.

 -- Kartik Mistry <kartik@debian.org>  Mon, 23 Sep 2013 08:46:01 +0530

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,10 @@
                libxt-dev,
                x11proto-core-dev
 Maintainer: Kartik Mistry <kartik@debian.org>
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://www.jwz.org/xdaliclock/
+Vcs-Git: git://anonscm.debian.org/collab-maint/xdaliclock.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/xdaliclock.git;a=summary
 
 Package: xdaliclock
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -28,4 +28,4 @@
 	cd X11 && $(MAKE) install_prefix=$(CURDIR)/debian/xdaliclock install
 
 %:
-	dh $@
+	dh --with autotools_dev $@

## xdaliclock 2.41

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 TARFILES	= README Makefile version.h \
 		  config.guess config.sub install-sh \
 		  mac128/README mac128/*.*
-NUMBERS		= font/dalifont*.{gif,png,ai,psd,gz} font/*.xbm
+NUMBERS		= font/dalifont*.{gif,png,ai,psd.gz} font/*.xbm
 TAR		= tar
 
 
@@ -124,7 +124,7 @@
       ` ";								    \
     cd $$d ; done ;							    \
   echo creating tar file archive/$${NAME}.tar.gz... ;			    \
-  GZIP="-9v" $(TAR) -vchzf archive/$${NAME}.tar.gz			    \
+  GZIP="-9v" $(TAR) -vczf archive/$${NAME}.tar.gz			    \
     `echo $(TARFILES) $$FILES $(NUMBERS)				    \
    | sed "s|^|$$NAME/|g; s| | $$NAME/|g" ` ;				    \
   rm $$NAME ;								    \
@@ -174,6 +174,8 @@
 									    \
   cp -p archive/$$DMG $$DEST/$$DMG ;					    \
   chmod u+w $$DEST/$$DMG ;						    \
+									    \
+  cp -p OSX/updates.xml $$DEST/ ;					    \
 									    \
   cd $$DEST ;								    \
 									    \

=== OSX/Makefile ===
--- 
+++ 
@@ -5,6 +5,8 @@
 ARCH       = -arch i386 -arch x86_64
 CERT       = 'Jamie Zawinski'
 CERT       = 'iPhone Developer: Jamie Zawinski (Y5M82TL69N)'
+SETFILE    = /Applications/Xcode.app/Contents/Developer/Tools/SetFile
+SETICON    = /usr/local/bin/seticon
 
 default: release
 all: debug release
@@ -17,8 +19,9 @@
 	-rm -f config.status config.cache config.log \
 	  *.bak *.rej TAGS *~ "#"*
 	-rm -rf autom4te*.cache
-	-rm -rf build
-
+	-rm -rf build Sparkle.framework
+
+distdepend:: Sparkle.framework
 distdepend:: update_plist_version
 distdepend:: update_bindist_version
 
@@ -30,6 +33,13 @@
 
 release:: check_versions
 release:: sign
+
+Sparkle.framework:
+	unzip "../archive/Sparkle 1.5b6.zip" \
+	  "With Garbage Collection/Sparkle.framework/*"
+	mv "With Garbage Collection/Sparkle.framework" .
+	rmdir "With Garbage Collection"
+	cd Sparkle.framework/Resources/ && ln -sf fr.lproj fr_CA.lproj
 
 
 distdepend:: DaliClockPhone72.png DaliClockPhone57.png
@@ -45,11 +55,11 @@
 
 
 sign:
-	codesign -vfs $(CERT) build/Release/*.app
-	codesign -vfs $(CERT) build/Release/*.saver
-	codesign -vfs $(CERT) build/Release/*.wdgt/*.widgetplugin
-	codesign -vfs $(CERT) build/Release/*.wdgt
-#	codesign -vfs $(CERT) build/Release-iphoneos/*.app
+	codesign --deep -vfs $(CERT) build/Release/*.app
+	codesign --deep -vfs $(CERT) build/Release/*.saver
+	codesign --deep -vfs $(CERT) build/Release/*.wdgt/*.widgetplugin
+	codesign --deep -vfs $(CERT) build/Release/*.wdgt
+#	codesign --deep -vfs $(CERT) build/Release-iphoneos/*.app
 
 check_versions:
 	@\
@@ -57,7 +67,8 @@
   V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ;]*\).*/\1/p' < $$U` ;		\
   DIR=build/Release ;							\
   RESULT=0 ;								\
-  for P in `find $$DIR -name Info.plist` ; do				\
+  for P in `find $$DIR -name Info.plist |				\
+	    grep -v Sparkle.framework` ; do				\
      V2=`perl -0000 -n -e						\
 	'm@<key>CFBundleVersion</key>\s*<string>(.*?)</string>@si 	\
 	 && print $$1' < $$P` ;						\
@@ -76,7 +87,7 @@
 	     -o -name 'jwz.*' -o -name '*.widgetplugin' \
 	     -o -name '*.psd' -o -name '*.ai' \) \
 	     -prune \) \
-	  -o -type f -print \
+	  -o \( -type f -o -type l \) -print \
 	| sed 's@^\./@@' \
 	| sort`
 
@@ -128,6 +139,34 @@
   done ;								    \
   rm $$T
 
+
+updates.xml::
+	./updates.pl DaliClock ../README ../archive ~/www/xdaliclock
+	@$(MAKE) test_sig
+
+test_sig::
+	@								    \
+  U=../version.h ;							    \
+  V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ;]*\).*/\1/p' < $$U` ;		    \
+  V=`echo $$V | sed 's/\.//g'` ;					    \
+  ZIP="../archive/DaliClock-$$V.dmg" ;					    \
+  SIG=`sed -n 's/^.*dsaSignature="\(.*\)".*/\1/p' updates.xml` ;	    \
+  PUB="sparkle_dsa_pub.pem" ;						    \
+  NN="t.$$$$" ;								    \
+  SIGB=/tmp/$$NN.sig ;							    \
+  HASH=/tmp/$$NN.hash ;							    \
+  rm -f "$$SIGB" "$$HASH" ;						    \
+  echo "$$SIG " | base64 -D  > "$$SIGB" ;				    \
+  set -e ;								    \
+  for OPENSSL in /usr/bin/openssl /opt/local/bin/openssl ; do		    \
+    $$OPENSSL dgst -sha1 -binary  < "$$ZIP"  > "$$HASH" ;		    \
+    /bin/echo -n "$$OPENSSL	`$$OPENSSL version`:	" ;		    \
+    $$OPENSSL dgst -dss1 -verify "$$PUB" -signature "$$SIGB" "$$HASH" ;	    \
+  done ;								    \
+  rm -f "$$SIGB" "$$HASH" ;						    \
+
+
+
 # -format UDBZ saves 4% over UDZO, but that's only 8KB.
 dmg:: distdepend check_versions
 	@								      \
@@ -149,26 +188,27 @@
   echo + mkdir "$$STAGE" ;						      \
          mkdir "$$STAGE" ;						      \
   FILES="$$SRC/*.app $$SRC/*.saver $$SRC/*.wdgt" ;			      \
-  echo + cp -pr $$FILES "$$STAGE" ;					      \
-         cp -pr $$FILES "$$STAGE" ;					      \
+  echo + cp -pR $$FILES "$$STAGE" ;					      \
+         cp -pR $$FILES "$$STAGE" ;					      \
   set -x ;								      \
   cp -p bindist.rtf "$$STAGE/ READ ME.rtf" ;				      \
   cp -p bindist-DS_Store "$$STAGE/.DS_Store" ;				      \
   cp -p bindist.webloc "$$STAGE/DaliClock for iPhone:iPad.webloc" ;	      \
-  /Developer/Tools/SetFile -a E "$$STAGE/ READ ME.rtf" ;		      \
-  /Developer/Tools/SetFile -a e $$STAGE/*.saver ;			      \
-  /Developer/Tools/SetFile -a e $$STAGE/*.wdgt ;			      \
-  /Developer/Tools/SetFile -a E $$STAGE/*.webloc ;			      \
-  seticon -d daliclockSaver.icns $$STAGE/*.saver ;			      \
-  seticon -d daliclockWidget.icns $$STAGE/*.wdgt ;			      \
-  seticon -d daliclock.icns $$STAGE/*.webloc ;				      \
+  ${SETFILE} -a E "$$STAGE/ READ ME.rtf" ;				      \
+  ${SETFILE} -a e $$STAGE/*.saver ;					      \
+  ${SETFILE} -a e $$STAGE/*.wdgt ;					      \
+  ${SETFILE} -a E $$STAGE/*.webloc ;					      \
+  $(SETICON) -d daliclockSaver.icns $$STAGE/*.saver ;			      \
+  $(SETICON) -d daliclockWidget.icns $$STAGE/*.wdgt ;			      \
+  $(SETICON) -d daliclock.icns $$STAGE/*.webloc ;			      \
   hdiutil makehybrid -quiet -ov -hfs -hfs-volume-name "$$VOLNAME"	      \
     -hfs-openfolder "$$STAGE" "$$STAGE" -o "$$TMPDMG" ;			      \
   rm -rf "$$STAGE" ;							      \
   hdiutil convert -quiet -ov -format UDZO -imagekey zlib-level=9	      \
     "$$TMPDMG" -o "$$DMG" ;						      \
   rm -f "$$TMPDMG" ;							      \
-  ls -ldhgF "$$DMG"
+  ls -ldhgF "$$DMG" ;							      \
+  $(MAKE) updates.xml ;							      \
 
 # Adding this is cute:
 #    hdiutil internet-enable -yes -quiet "$$DMG"

=== debian/changelog ===
xdaliclock (2.41-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    + Updated to Standards-Version 3.9.5

 -- Kartik Mistry <kartik@debian.org>  Fri, 25 Apr 2014 12:53:58 +0530

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                libxt-dev,
                x11proto-core-dev
 Maintainer: Kartik Mistry <kartik@debian.org>
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://www.jwz.org/xdaliclock/
 Vcs-Git: git://anonscm.debian.org/collab-maint/xdaliclock.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/xdaliclock.git;a=summary

=== debian/watch ===
version=3
opts=dversionmangle=s/\+debian// \
http://www.jwz.org/xdaliclock/xdaliclock-([\d\.]+)\.tar\.gz

## xdaliclock 2.43+debian

=== Makefile ===
--- 
+++ 
@@ -4,17 +4,17 @@
 TARFILES	= README Makefile version.h \
 		  config.guess config.sub install-sh \
 		  mac128/README mac128/*.*
-NUMBERS		= font/dalifont*.{gif,png,ai,psd.gz} font/*.xbm
+NUMBERS		= font/dalifont*.{gif,png,ai,psd.gz} font/*.{c,xbm}
 TAR		= tar
 
 
 default:
 	@echo ''; \
-	 echo '        please make one of: "x", "palm", "webos", "all", or "clean"'; \
+	 echo '        please make one of: "x", "palm", "webos", "android", "all", or "clean"'; \
 	 echo ''; \
 	 exit 5
 
-all:: OSX webos palm X11
+all:: OSX webos palm X11 android
 
 X11::   x11
 X::     X11
@@ -23,6 +23,7 @@
 OSX::   osx
 palm::  Palm
 webos:: WebOS
+android:: Android
 
 x11:: X11/Makefile
 	@echo '==============================================================='
@@ -48,6 +49,16 @@
 	@echo '==============================================================='
 	@echo ''
 	cd webos ; make
+
+pebble::
+	@echo '==============================================================='
+	@echo ''
+	cd pebble ; pebble build
+
+Android:: android/Makefile
+	@echo '==============================================================='
+	@echo ''
+	cd android ; make
 
 X11/Makefile:
 	@echo '==============================================================='
@@ -70,6 +81,8 @@
 	cd OSX ; make $@
 	cd palm ; make $@
 	cd webos ; make $@
+	cd pebble ; make $@
+	cd android ; make $@
 
 distclean: X11/Makefile gtk/Makefile palm/Makefile
 	cd X11 ; make $@
@@ -77,6 +90,8 @@
 	cd OSX ; make $@
 	cd palm ; make $@
 	cd webos ; make $@
+	cd pebble ; make $@
+	cd android ; make $@
 
 install:
 	@echo ''; \
@@ -92,12 +107,19 @@
 	 echo '      - to install the WebOS version: "cd webos; make", and'; \
 	 echo '        then send the .ipk to your Palm WebOS device.';\
 	 echo ''; \
+	 echo '      - to install the android version: "cd android; make", and'; \
+	 echo '        then send the .apk to your android device.';\
+	 echo ''; \
 	 exit 5
 
 dmg::
 	cd OSX ; $(MAKE) dmg
 
-tar: X11/Makefile gtk/Makefile palm/Makefile dmg
+apk::
+	cd android ; $(MAKE) apk
+
+tar: X11/Makefile gtk/Makefile palm/Makefile dmg apk _tar
+_tar:
 	@								    \
   for dir in X11 gtk palm ; do						    \
    ( cd $$dir ;								    \
@@ -106,16 +128,17 @@
      ./config.status ;							    \
      $(MAKE) distdepend );						    \
   done ;								    \
-  (cd X11; make update_spec_version) ;					    \
-  (cd gtk; make update_spec_version) ;					    \
-  (cd palm; make update_rsc_version) ;					    \
-  (cd webos; make update_release_date) ;				    \
-  (cd OSX; make update_plist_version) ;					    \
+  (cd X11; $(MAKE) update_spec_version) ;				    \
+  (cd gtk; $(MAKE) update_spec_version) ;				    \
+  (cd palm; $(MAKE) update_rsc_version) ;				    \
+  (cd webos; $(MAKE) update_release_date) ;				    \
+  (cd OSX; $(MAKE) update_plist_version) ;				    \
+  (cd android; $(MAKE) update_gradle_version update_gradle_app_id) ;	    \
   NAME=`sed -n								    \
   's/[^0-9]*\([0-9]\.[0-9][0-9]*\).*/xdaliclock-\1/p' version.h` ;	    \
   rm -rf $$NAME ; ln -s . $$NAME ;					    \
   FILES= ;								    \
-  for subdir in X11 gtk palm OSX webos ; do				    \
+  for subdir in X11 gtk palm OSX webos pebble android ; do		    \
     d=`pwd` ;								    \
     cd $$subdir ;							    \
     FILES="$$FILES `$(MAKE) echo_tarfiles				    \
@@ -124,7 +147,8 @@
       ` ";								    \
     cd $$d ; done ;							    \
   echo creating tar file archive/$${NAME}.tar.gz... ;			    \
-  GZIP="-9v" $(TAR) -vczf archive/$${NAME}.tar.gz			    \
+  export COPYFILE_DISABLE=true ;					    \
+  GZIP="-9v" $(TAR) --check-links -vczf archive/$${NAME}.tar.gz		    \
     `echo $(TARFILES) $$FILES $(NUMBERS)				    \
    | sed "s|^|$$NAME/|g; s| | $$NAME/|g" ` ;				    \
   rm $$NAME ;								    \
@@ -140,6 +164,7 @@
   HEAD3="DaliClock-$$VERS2"						 ;  \
   TAR="x$$HEAD.tar.gz"							 ;  \
   DMG="$$HEAD3.dmg"							 ;  \
+  APK="$$HEAD3.apk"							 ;  \
 									    \
   if [ ! -f archive/$$TAR ]; then					    \
     echo "archive/$$TAR does not exist!  Did you forget to \`make tar'?" ;  \
@@ -150,8 +175,14 @@
     echo "archive/$$DMG does not exist!  Did you forget to \`make dmg'?" ;  \
     exit 1 ; 								    \
   fi ;									    \
+									    \
+  if [ ! -f archive/$$APK ]; then					    \
+    echo "archive/$$APK does not exist!  Did you forget to \`make apk'?" ;  \
+    exit 1 ; 								    \
+  fi ;									    \
   chmod a-w archive/$$TAR ;						    \
   chmod a-w archive/$$DMG ;						    \
+  chmod a-w archive/$$APK ;						    \
 									    \
   if [ -f $$DEST/$$TAR ]; then						    \
     /bin/echo -n "WARNING: $$DEST/$$TAR already exists!  Overwrite? ";	    \
@@ -169,11 +200,24 @@
     fi ;								    \
   fi ;									    \
 									    \
+  if [ -f $$DEST/$$APK ]; then						    \
+    /bin/echo -n "WARNING: $$DEST/$$APK already exists!  Overwrite? ";	    \
+    read line;								    \
+    if [ "x$$line" != "xyes" -a "x$$line" != "xy" ]; then		    \
+      exit 1 ; 								    \
+    fi ;								    \
+  fi ;									    \
+									    \
+  ( cd $$DEST ;	git pull . ) ;						    \
+									    \
   cp -p archive/$$TAR $$DEST/$$TAR ;					    \
   chmod u+w $$DEST/$$TAR ;						    \
 									    \
   cp -p archive/$$DMG $$DEST/$$DMG ;					    \
   chmod u+w $$DEST/$$DMG ;						    \
+									    \
+  cp -p archive/$$APK $$DEST/$$APK ;					    \
+  chmod u+w $$DEST/$$APK ;						    \
 									    \
   cp -p OSX/updates.xml $$DEST/ ;					    \
 									    \
@@ -188,14 +232,14 @@
   diff -U0 index.html $$TMP ;						    \
   echo '' ;								    \
 									    \
-  for EXT in tar.gz dmg ; do						    \
+  for EXT in tar.gz dmg apk ; do					    \
     OLDEST=`ls *.$$EXT | fgrep -v 235.dmg | head -n 1` ;		    \
     /bin/echo -n "Delete $$DEST/$$OLDEST? ";				    \
     read line;								    \
     if [ "x$$line" = "xyes" -o "x$$line" = "xy" ]; then			    \
       set -x ;								    \
       rm $$OLDEST ;							    \
-      cvs remove $$OLDEST ;						    \
+      git rm $$OLDEST ;							    \
       set +x ;								    \
     fi ;								    \
   done ;								    \
@@ -204,6 +248,6 @@
   rm -f $$TMP ;								    \
 									    \
   set -x ;								    \
-  cvs add -kb $$TAR $$DMG ;						    \
-  cvs commit -m "$$VERS"
-
+  git add index.html updates.xml $$TAR $$DMG $$APK ;			    \
+  git commit -m "$$VERS" ;						    \
+  git push

=== debian/changelog ===
xdaliclock (2.43+debian-3) unstable; urgency=low

  * debian/control:
    + Fixed Vcs-Git URL.
    + Updated Standards-Version to 4.2.1
  * debian/copyright:
    + Added comment about upstream source repackage.

 -- Kartik Mistry <kartik@debian.org>  Wed, 28 Nov 2018 18:04:31 +0530

xdaliclock (2.43+debian-2) unstable; urgency=low

  * debian/control:
    + Updated Standards-Version to 4.1.3.
    + Updated Vcs-* URLs.
    + Updated debhelper Build-Dep to 11.
    + Removed auttools-dev from Build-Dep.
  * Set debian/compat to 11.
  * debian/rules:
    + Removed deprecated --with autotools_dev.
    + Don't set CFLAGS.
  * Use https in all URLs.

 -- Kartik Mistry <kartik@debian.org>  Fri, 26 Jan 2018 12:56:52 -0800

xdaliclock (2.43+debian-1) unstable; urgency=low

  * New upstream release:
    + Repacked upstream source to remove other OSs. No other changes.
  * debian/control:
    + Updated Standards-Version to 3.9.8
    + Use dpkg-buildflag instead of hardening-wrapper.
    + Bumped dh dependency.
    + Updated Vcs-* URLs.
  * debian/copyright:
    + Fixed file location and license.
  * debian/rules:
    + Updated for dpkg-buildflag usage.

 -- Kartik Mistry <kartik@debian.org>  Fri, 08 Jul 2016 11:52:08 +0530

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,17 @@
 Source: xdaliclock
 Section: x11
 Priority: optional
-Build-Depends: autotools-dev,
-               debhelper (>= 7),
-               hardening-wrapper,
+Build-Depends: debhelper (>= 11),
+               dpkg-dev (>= 1.16.1.1),
                libx11-dev,
                libxext-dev,
                libxt-dev,
                x11proto-core-dev
 Maintainer: Kartik Mistry <kartik@debian.org>
-Standards-Version: 3.9.5
-Homepage: http://www.jwz.org/xdaliclock/
-Vcs-Git: git://anonscm.debian.org/collab-maint/xdaliclock.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/xdaliclock.git;a=summary
+Standards-Version: 4.2.1
+Homepage: https://www.jwz.org/xdaliclock/
+Vcs-Git: https://salsa.debian.org/debian/xdaliclock.git
+Vcs-Browser: https://salsa.debian.org/debian/xdaliclock
 
 Package: xdaliclock
 Architecture: any

=== debian/watch ===
version=3
opts=dversionmangle=s/\+debian// \
https://www.jwz.org/xdaliclock/xdaliclock-([\d\.]+)\.tar\.gz
